﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Web;
using System.Xml;

namespace EncodeDecodeDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            EncodingInfo[] encs = Encoding.GetEncodings();

            for (int k = 0; k < encs.Length; k++)
            {
                cmbEncoding.Items.Add(encs[k].DisplayName + " (" + encs[k].CodePage + ")");

                if (encs[k].CodePage == 65001)
                {
                    cmbEncoding.SelectedIndex = k;
                }
            }

        }

        private void btnEncodeBase64_Click(object sender, EventArgs e)
        {
            Encoding enc = null;

            string enctxt = cmbEncoding.SelectedItem.ToString(); ;
            int epos = enctxt.LastIndexOf("(");

            if (epos >= 0)
            {
                string enccp = enctxt.Substring(epos + 1, enctxt.Length - epos - 1 - 1);

                Console.WriteLine(enccp);

                enc = Encoding.GetEncoding(int.Parse(enccp));
            }
            else
            {
                enc = System.Text.Encoding.UTF8;
            }

            bool insert_line_breaks = true;
            
            if (insert_line_breaks)
            {                
                textBox1.Text = System.Convert.ToBase64String(enc.GetBytes(textBox1.Text), Base64FormattingOptions.InsertLineBreaks);
            }
            else
            {            
                textBox1.Text = System.Convert.ToBase64String(enc.GetBytes(textBox1.Text), Base64FormattingOptions.None);
            }

        }

        private void btnDecodeBase64_Click(object sender, EventArgs e)
        {
            Encoding enc = null;

            string enctxt = cmbEncoding.SelectedItem.ToString(); ;
            int epos = enctxt.LastIndexOf("(");

            if (epos >= 0)
            {
                string enccp = enctxt.Substring(epos + 1, enctxt.Length - epos - 1 - 1);

                Console.WriteLine(enccp);

                enc = Encoding.GetEncoding(int.Parse(enccp));
            }
            else
            {
                enc = System.Text.Encoding.UTF8;
            }

            textBox1.Text = enc.GetString(System.Convert.FromBase64String(textBox1.Text));

        }

        private void btnEncodeHTML_Click(object sender, EventArgs e)
        {
            textBox1.Text = HttpUtility.HtmlEncode(textBox1.Text);

        }

        private void btnDecodeHTML_Click(object sender, EventArgs e)
        {
            textBox1.Text = HttpUtility.HtmlDecode(textBox1.Text);
        }

        private void btnEncodeURL_Click(object sender, EventArgs e)
        {
            textBox1.Text = HttpUtility.UrlEncode(textBox1.Text);
        }

        private void btnDecodeURL_Click(object sender, EventArgs e)
        {
            textBox1.Text = HttpUtility.UrlDecode(textBox1.Text);
        }

        private void btnEncodeXML_Click(object sender, EventArgs e)
        {
            XmlDocument xmlDoc = new XmlDocument();

            XmlElement xmlElement = xmlDoc.CreateElement("Str");

            xmlElement.InnerText = textBox1.Text;

            textBox1.Text = xmlElement.InnerXml;

        }

        private void btnDecodeXML_Click(object sender, EventArgs e)
        {
            XmlDocument xmlDoc = new XmlDocument();

            xmlDoc.LoadXml("<root1>" + textBox1.Text + "</root1>");

            textBox1.Text = xmlDoc.InnerText;

        }
    }
}
